<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestHeaderUserField StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestHeaderUserField
 * @subpackage Structs
 */
class CreateFromRequestHeaderUserField extends AbstractStructBase
{
    /**
     * The Id
     * @var int
     */
    public $Id;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldValue
     */
    public $Value;
    /**
     * The ValueType
     * @var string
     */
    public $ValueType;
    /**
     * Constructor method for CreateFromRequestHeaderUserField
     * @uses CreateFromRequestHeaderUserField::setId()
     * @uses CreateFromRequestHeaderUserField::setValue()
     * @uses CreateFromRequestHeaderUserField::setValueType()
     * @param int $id
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldValue $value
     * @param string $valueType
     */
    public function __construct($id = null, \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldValue $value = null, $valueType = null)
    {
        $this
            ->setId($id)
            ->setValue($value)
            ->setValueType($valueType);
    }
    /**
     * Get Id value
     * @return int|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Value value
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldValue|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldValue $value
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField
     */
    public function setValue(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldValue $value = null)
    {
        $this->Value = $value;
        return $this;
    }
    /**
     * Get ValueType value
     * @return string|null
     */
    public function getValueType()
    {
        return $this->ValueType;
    }
    /**
     * Set ValueType value
     * @uses \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderUserFieldType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderUserFieldType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $valueType
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField
     */
    public function setValueType($valueType = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderUserFieldType::valueIsValid($valueType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderUserFieldType', is_array($valueType) ? implode(', ', $valueType) : var_export($valueType, true), implode(', ', \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderUserFieldType::getValidValues())), __LINE__);
        }
        $this->ValueType = $valueType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
