<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestHeaderUserFieldCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestHeaderUserFieldCollection
 * @subpackage Structs
 */
class CreateFromRequestHeaderUserFieldCollection extends AbstractStructBase
{
    /**
     * The UserField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField[]
     */
    public $UserField;
    /**
     * Constructor method for CreateFromRequestHeaderUserFieldCollection
     * @uses CreateFromRequestHeaderUserFieldCollection::setUserField()
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField[] $userField
     */
    public function __construct(array $userField = array())
    {
        $this
            ->setUserField($userField);
    }
    /**
     * Get UserField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField[]|null
     */
    public function getUserField()
    {
        return isset($this->UserField) ? $this->UserField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserFieldForArrayConstraintsFromSetUserField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createFromRequestHeaderUserFieldCollectionUserFieldItem) {
            // validation for constraint: itemType
            if (!$createFromRequestHeaderUserFieldCollectionUserFieldItem instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField) {
                $invalidValues[] = is_object($createFromRequestHeaderUserFieldCollectionUserFieldItem) ? get_class($createFromRequestHeaderUserFieldCollectionUserFieldItem) : sprintf('%s(%s)', gettype($createFromRequestHeaderUserFieldCollectionUserFieldItem), var_export($createFromRequestHeaderUserFieldCollectionUserFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserField property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField[] $userField
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldCollection
     */
    public function setUserField(array $userField = array())
    {
        // validation for constraint: array
        if ('' !== ($userFieldArrayErrorMessage = self::validateUserFieldForArrayConstraintsFromSetUserField($userField))) {
            throw new \InvalidArgumentException($userFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($userField) || (is_array($userField) && empty($userField))) {
            unset($this->UserField);
        } else {
            $this->UserField = $userField;
        }
        return $this;
    }
    /**
     * Add item to UserField value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField $item
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldCollection
     */
    public function addToUserField(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField) {
            throw new \InvalidArgumentException(sprintf('The UserField property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserField[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserFieldCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
