<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserDefinedText ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: q35:ArrayOfUserDefinedText
 * @subpackage Arrays
 */
class ArrayOfUserDefinedText extends AbstractStructArrayBase
{
    /**
     * The UserDefinedText
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText[]
     */
    public $UserDefinedText;
    /**
     * Constructor method for ArrayOfUserDefinedText
     * @uses ArrayOfUserDefinedText::setUserDefinedText()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText[] $userDefinedText
     */
    public function __construct(array $userDefinedText = array())
    {
        $this
            ->setUserDefinedText($userDefinedText);
    }
    /**
     * Get UserDefinedText value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText[]|null
     */
    public function getUserDefinedText()
    {
        return isset($this->UserDefinedText) ? $this->UserDefinedText : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserDefinedText method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserDefinedText method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserDefinedTextForArrayConstraintsFromSetUserDefinedText(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUserDefinedTextUserDefinedTextItem) {
            // validation for constraint: itemType
            if (!$arrayOfUserDefinedTextUserDefinedTextItem instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText) {
                $invalidValues[] = is_object($arrayOfUserDefinedTextUserDefinedTextItem) ? get_class($arrayOfUserDefinedTextUserDefinedTextItem) : sprintf('%s(%s)', gettype($arrayOfUserDefinedTextUserDefinedTextItem), var_export($arrayOfUserDefinedTextUserDefinedTextItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserDefinedText property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserDefinedText value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText[] $userDefinedText
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText
     */
    public function setUserDefinedText(array $userDefinedText = array())
    {
        // validation for constraint: array
        if ('' !== ($userDefinedTextArrayErrorMessage = self::validateUserDefinedTextForArrayConstraintsFromSetUserDefinedText($userDefinedText))) {
            throw new \InvalidArgumentException($userDefinedTextArrayErrorMessage, __LINE__);
        }
        if (is_null($userDefinedText) || (is_array($userDefinedText) && empty($userDefinedText))) {
            unset($this->UserDefinedText);
        } else {
            $this->UserDefinedText = $userDefinedText;
        }
        return $this;
    }
    /**
     * Add item to UserDefinedText value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText $item
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText
     */
    public function addToUserDefinedText(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedText property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserDefinedText[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedText|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserDefinedText
     */
    public function getAttributeName()
    {
        return 'UserDefinedText';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
