<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerDataBase StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: q18:CustomerDataBase
 * @subpackage Structs
 */
class CustomerDataBase extends AbstractStructBase
{
    /**
     * The ActivitySectorCode
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Code of the customer's activity sector - Related to column [TIERS.T_SECTEUR].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ActivitySectorCode;
    /**
     * The AddressData
     * Meta information extracted from the WSDL
     * - documentation: [Optional].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddressDataType
     */
    public $AddressData;
    /**
     * The AlternateFirstName
     * Meta information extracted from the WSDL
     * - documentation: Customer's middle name. - Related to column [TIERS.T_PRENOM2].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AlternateFirstName;
    /**
     * The AlternateLastName
     * Meta information extracted from the WSDL
     * - documentation: Customer's alternate last name. - Related to column [TIERS.T_NOM2].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AlternateLastName;
    /**
     * The BusinessAreaCode
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Code of the customer's business area - Related to column [TIERS.T_ZONECOM].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BusinessAreaCode;
    /**
     * The CpfCnpjCode
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Customer's CPF/CNPJ code - Related to column [TIERSCOMPL.YTC_CODECPFCNPJ].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CpfCnpjCode;
    /**
     * The EmailData
     * Meta information extracted from the WSDL
     * - documentation: [Optional].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType
     */
    public $EmailData;
    /**
     * The FirstName
     * Meta information extracted from the WSDL
     * - documentation: Customer's First name. - Related to column [TIERS.T_PRENOM].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FirstName;
    /**
     * The IsCompany
     * Meta information extracted from the WSDL
     * - documentation: Property specifying if the customer is a company. - Related to column [TIERS.T_PARTICULIER].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsCompany;
    /**
     * The LastModificationDate
     * Meta information extracted from the WSDL
     * - documentation: [Added 2018/02 - V1400] [Optional] - Date of last change, only available in read-only mode - Related to column [TIERS.T_DATEMODIF].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastModificationDate;
    /**
     * The LastName
     * Meta information extracted from the WSDL
     * - documentation: Customer's last name. - Related to column [TIERS.T_LIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastName;
    /**
     * The MunicipalRegistration
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Customer's municipal registration - Related to column [TIERSCOMPL.YTC_INSCMUNICIPALE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MunicipalRegistration;
    /**
     * The OriginCode
     * Meta information extracted from the WSDL
     * - documentation: [Added 2018/02 - V1400] [Optional] - Customer origin code - Related to column [TIERS.T_ORIGINETIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OriginCode;
    /**
     * The PhoneData
     * Meta information extracted from the WSDL
     * - documentation: [Optional].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\PhoneDataType
     */
    public $PhoneData;
    /**
     * The PriceListCode
     * Meta information extracted from the WSDL
     * - documentation: [Added 2018/02 - V1400] [Optional] - Customer price list code - Related to column [TIERS.T_TARIFTIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PriceListCode;
    /**
     * The RegionalRegistration
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Customer's regional registration - Related to column [TIERSCOMPL.YTC_INSCFEDERALE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RegionalRegistration;
    /**
     * The RiskLevel
     * Meta information extracted from the WSDL
     * - documentation: [Added 2018/02 - V1400] [Optional] - Customer risk level - Related to column [TIERS.T_ETATRISQUE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RiskLevel;
    /**
     * The SalesPerson2Id
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/09 - V1201] [Optional] - Identifier of seller #2 - Related to column [TIERSCOMPL.YTC_REPRESENTANT2].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPerson2Id;
    /**
     * The SalesPerson3Id
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/09 - V1201] [Optional] - Identifier of seller #3 - Related to column [TIERSCOMPL.YTC_REPRESENTANT3].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPerson3Id;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/09 - V1201] [Optional] - Identifier of main seller - Related to column [TIERS.T_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The TitleId
     * Meta information extracted from the WSDL
     * - documentation: Customer's title. - Related to column [TIERS.T_JURIDIQUE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TitleId;
    /**
     * The UserDefinedBooleans
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/07] [Alpha] - Customer's user-defined Booleans. - Related to column [TIERSCOMPL.YTC_BOOLLIBRE1..3].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean
     */
    public $UserDefinedBooleans;
    /**
     * The UserDefinedData
     * Meta information extracted from the WSDL
     * - documentation: [Optional] - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS1..A].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public $UserDefinedData;
    /**
     * The UserDefinedDates
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/07] [Optional] - Customer's user-defined dates. - Related to column [TIERSCOMPL.YTC_DATELIBRE1..3].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedDate
     */
    public $UserDefinedDates;
    /**
     * The UserDefinedTexts
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/07] [Optional] - Customer's user-defines tables. - Related to column [TIERSCOMPL.YTC_TEXTELIBRE1..3].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText
     */
    public $UserDefinedTexts;
    /**
     * The UserDefinedValues
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/07] [Optional] - Customer's user-defined numerical values. - Related to column [TIERSCOMPL.YTC_VALLIBRE1..3].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue
     */
    public $UserDefinedValues;
    /**
     * The UsualStoreId
     * Meta information extracted from the WSDL
     * - documentation: Customer's usual store ID. - Related to column [TIERS.T_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UsualStoreId;
    /**
     * Constructor method for CustomerDataBase
     * @uses CustomerDataBase::setActivitySectorCode()
     * @uses CustomerDataBase::setAddressData()
     * @uses CustomerDataBase::setAlternateFirstName()
     * @uses CustomerDataBase::setAlternateLastName()
     * @uses CustomerDataBase::setBusinessAreaCode()
     * @uses CustomerDataBase::setCpfCnpjCode()
     * @uses CustomerDataBase::setEmailData()
     * @uses CustomerDataBase::setFirstName()
     * @uses CustomerDataBase::setIsCompany()
     * @uses CustomerDataBase::setLastModificationDate()
     * @uses CustomerDataBase::setLastName()
     * @uses CustomerDataBase::setMunicipalRegistration()
     * @uses CustomerDataBase::setOriginCode()
     * @uses CustomerDataBase::setPhoneData()
     * @uses CustomerDataBase::setPriceListCode()
     * @uses CustomerDataBase::setRegionalRegistration()
     * @uses CustomerDataBase::setRiskLevel()
     * @uses CustomerDataBase::setSalesPerson2Id()
     * @uses CustomerDataBase::setSalesPerson3Id()
     * @uses CustomerDataBase::setSalesPersonId()
     * @uses CustomerDataBase::setTitleId()
     * @uses CustomerDataBase::setUserDefinedBooleans()
     * @uses CustomerDataBase::setUserDefinedData()
     * @uses CustomerDataBase::setUserDefinedDates()
     * @uses CustomerDataBase::setUserDefinedTexts()
     * @uses CustomerDataBase::setUserDefinedValues()
     * @uses CustomerDataBase::setUsualStoreId()
     * @param string $activitySectorCode
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddressDataType $addressData
     * @param string $alternateFirstName
     * @param string $alternateLastName
     * @param string $businessAreaCode
     * @param string $cpfCnpjCode
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType $emailData
     * @param string $firstName
     * @param bool $isCompany
     * @param string $lastModificationDate
     * @param string $lastName
     * @param string $municipalRegistration
     * @param string $originCode
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\PhoneDataType $phoneData
     * @param string $priceListCode
     * @param string $regionalRegistration
     * @param string $riskLevel
     * @param string $salesPerson2Id
     * @param string $salesPerson3Id
     * @param string $salesPersonId
     * @param string $titleId
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean $userDefinedBooleans
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType $userDefinedData
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText $userDefinedTexts
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue $userDefinedValues
     * @param string $usualStoreId
     */
    public function __construct($activitySectorCode = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddressDataType $addressData = null, $alternateFirstName = null, $alternateLastName = null, $businessAreaCode = null, $cpfCnpjCode = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType $emailData = null, $firstName = null, $isCompany = null, $lastModificationDate = null, $lastName = null, $municipalRegistration = null, $originCode = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\PhoneDataType $phoneData = null, $priceListCode = null, $regionalRegistration = null, $riskLevel = null, $salesPerson2Id = null, $salesPerson3Id = null, $salesPersonId = null, $titleId = null, \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean $userDefinedBooleans = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType $userDefinedData = null, \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null, \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText $userDefinedTexts = null, \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue $userDefinedValues = null, $usualStoreId = null)
    {
        $this
            ->setActivitySectorCode($activitySectorCode)
            ->setAddressData($addressData)
            ->setAlternateFirstName($alternateFirstName)
            ->setAlternateLastName($alternateLastName)
            ->setBusinessAreaCode($businessAreaCode)
            ->setCpfCnpjCode($cpfCnpjCode)
            ->setEmailData($emailData)
            ->setFirstName($firstName)
            ->setIsCompany($isCompany)
            ->setLastModificationDate($lastModificationDate)
            ->setLastName($lastName)
            ->setMunicipalRegistration($municipalRegistration)
            ->setOriginCode($originCode)
            ->setPhoneData($phoneData)
            ->setPriceListCode($priceListCode)
            ->setRegionalRegistration($regionalRegistration)
            ->setRiskLevel($riskLevel)
            ->setSalesPerson2Id($salesPerson2Id)
            ->setSalesPerson3Id($salesPerson3Id)
            ->setSalesPersonId($salesPersonId)
            ->setTitleId($titleId)
            ->setUserDefinedBooleans($userDefinedBooleans)
            ->setUserDefinedData($userDefinedData)
            ->setUserDefinedDates($userDefinedDates)
            ->setUserDefinedTexts($userDefinedTexts)
            ->setUserDefinedValues($userDefinedValues)
            ->setUsualStoreId($usualStoreId);
    }
    /**
     * Get ActivitySectorCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getActivitySectorCode()
    {
        return isset($this->ActivitySectorCode) ? $this->ActivitySectorCode : null;
    }
    /**
     * Set ActivitySectorCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $activitySectorCode
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setActivitySectorCode($activitySectorCode = null)
    {
        // validation for constraint: string
        if (!is_null($activitySectorCode) && !is_string($activitySectorCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($activitySectorCode, true), gettype($activitySectorCode)), __LINE__);
        }
        if (is_null($activitySectorCode) || (is_array($activitySectorCode) && empty($activitySectorCode))) {
            unset($this->ActivitySectorCode);
        } else {
            $this->ActivitySectorCode = $activitySectorCode;
        }
        return $this;
    }
    /**
     * Get AddressData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddressDataType|null
     */
    public function getAddressData()
    {
        return isset($this->AddressData) ? $this->AddressData : null;
    }
    /**
     * Set AddressData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddressDataType $addressData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setAddressData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddressDataType $addressData = null)
    {
        if (is_null($addressData) || (is_array($addressData) && empty($addressData))) {
            unset($this->AddressData);
        } else {
            $this->AddressData = $addressData;
        }
        return $this;
    }
    /**
     * Get AlternateFirstName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAlternateFirstName()
    {
        return isset($this->AlternateFirstName) ? $this->AlternateFirstName : null;
    }
    /**
     * Set AlternateFirstName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $alternateFirstName
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setAlternateFirstName($alternateFirstName = null)
    {
        // validation for constraint: string
        if (!is_null($alternateFirstName) && !is_string($alternateFirstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($alternateFirstName, true), gettype($alternateFirstName)), __LINE__);
        }
        if (is_null($alternateFirstName) || (is_array($alternateFirstName) && empty($alternateFirstName))) {
            unset($this->AlternateFirstName);
        } else {
            $this->AlternateFirstName = $alternateFirstName;
        }
        return $this;
    }
    /**
     * Get AlternateLastName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAlternateLastName()
    {
        return isset($this->AlternateLastName) ? $this->AlternateLastName : null;
    }
    /**
     * Set AlternateLastName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $alternateLastName
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setAlternateLastName($alternateLastName = null)
    {
        // validation for constraint: string
        if (!is_null($alternateLastName) && !is_string($alternateLastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($alternateLastName, true), gettype($alternateLastName)), __LINE__);
        }
        if (is_null($alternateLastName) || (is_array($alternateLastName) && empty($alternateLastName))) {
            unset($this->AlternateLastName);
        } else {
            $this->AlternateLastName = $alternateLastName;
        }
        return $this;
    }
    /**
     * Get BusinessAreaCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBusinessAreaCode()
    {
        return isset($this->BusinessAreaCode) ? $this->BusinessAreaCode : null;
    }
    /**
     * Set BusinessAreaCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $businessAreaCode
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setBusinessAreaCode($businessAreaCode = null)
    {
        // validation for constraint: string
        if (!is_null($businessAreaCode) && !is_string($businessAreaCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($businessAreaCode, true), gettype($businessAreaCode)), __LINE__);
        }
        if (is_null($businessAreaCode) || (is_array($businessAreaCode) && empty($businessAreaCode))) {
            unset($this->BusinessAreaCode);
        } else {
            $this->BusinessAreaCode = $businessAreaCode;
        }
        return $this;
    }
    /**
     * Get CpfCnpjCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCpfCnpjCode()
    {
        return isset($this->CpfCnpjCode) ? $this->CpfCnpjCode : null;
    }
    /**
     * Set CpfCnpjCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cpfCnpjCode
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setCpfCnpjCode($cpfCnpjCode = null)
    {
        // validation for constraint: string
        if (!is_null($cpfCnpjCode) && !is_string($cpfCnpjCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpfCnpjCode, true), gettype($cpfCnpjCode)), __LINE__);
        }
        if (is_null($cpfCnpjCode) || (is_array($cpfCnpjCode) && empty($cpfCnpjCode))) {
            unset($this->CpfCnpjCode);
        } else {
            $this->CpfCnpjCode = $cpfCnpjCode;
        }
        return $this;
    }
    /**
     * Get EmailData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType|null
     */
    public function getEmailData()
    {
        return isset($this->EmailData) ? $this->EmailData : null;
    }
    /**
     * Set EmailData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType $emailData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setEmailData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType $emailData = null)
    {
        if (is_null($emailData) || (is_array($emailData) && empty($emailData))) {
            unset($this->EmailData);
        } else {
            $this->EmailData = $emailData;
        }
        return $this;
    }
    /**
     * Get FirstName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFirstName()
    {
        return isset($this->FirstName) ? $this->FirstName : null;
    }
    /**
     * Set FirstName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $firstName
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        if (is_null($firstName) || (is_array($firstName) && empty($firstName))) {
            unset($this->FirstName);
        } else {
            $this->FirstName = $firstName;
        }
        return $this;
    }
    /**
     * Get IsCompany value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsCompany()
    {
        return isset($this->IsCompany) ? $this->IsCompany : null;
    }
    /**
     * Set IsCompany value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isCompany
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setIsCompany($isCompany = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCompany) && !is_bool($isCompany)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCompany, true), gettype($isCompany)), __LINE__);
        }
        if (is_null($isCompany) || (is_array($isCompany) && empty($isCompany))) {
            unset($this->IsCompany);
        } else {
            $this->IsCompany = $isCompany;
        }
        return $this;
    }
    /**
     * Get LastModificationDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastModificationDate()
    {
        return isset($this->LastModificationDate) ? $this->LastModificationDate : null;
    }
    /**
     * Set LastModificationDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastModificationDate
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setLastModificationDate($lastModificationDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastModificationDate) && !is_string($lastModificationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastModificationDate, true), gettype($lastModificationDate)), __LINE__);
        }
        if (is_null($lastModificationDate) || (is_array($lastModificationDate) && empty($lastModificationDate))) {
            unset($this->LastModificationDate);
        } else {
            $this->LastModificationDate = $lastModificationDate;
        }
        return $this;
    }
    /**
     * Get LastName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastName()
    {
        return isset($this->LastName) ? $this->LastName : null;
    }
    /**
     * Set LastName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastName
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        if (is_null($lastName) || (is_array($lastName) && empty($lastName))) {
            unset($this->LastName);
        } else {
            $this->LastName = $lastName;
        }
        return $this;
    }
    /**
     * Get MunicipalRegistration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMunicipalRegistration()
    {
        return isset($this->MunicipalRegistration) ? $this->MunicipalRegistration : null;
    }
    /**
     * Set MunicipalRegistration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $municipalRegistration
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setMunicipalRegistration($municipalRegistration = null)
    {
        // validation for constraint: string
        if (!is_null($municipalRegistration) && !is_string($municipalRegistration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($municipalRegistration, true), gettype($municipalRegistration)), __LINE__);
        }
        if (is_null($municipalRegistration) || (is_array($municipalRegistration) && empty($municipalRegistration))) {
            unset($this->MunicipalRegistration);
        } else {
            $this->MunicipalRegistration = $municipalRegistration;
        }
        return $this;
    }
    /**
     * Get OriginCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOriginCode()
    {
        return isset($this->OriginCode) ? $this->OriginCode : null;
    }
    /**
     * Set OriginCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $originCode
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setOriginCode($originCode = null)
    {
        // validation for constraint: string
        if (!is_null($originCode) && !is_string($originCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originCode, true), gettype($originCode)), __LINE__);
        }
        if (is_null($originCode) || (is_array($originCode) && empty($originCode))) {
            unset($this->OriginCode);
        } else {
            $this->OriginCode = $originCode;
        }
        return $this;
    }
    /**
     * Get PhoneData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\PhoneDataType|null
     */
    public function getPhoneData()
    {
        return isset($this->PhoneData) ? $this->PhoneData : null;
    }
    /**
     * Set PhoneData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\PhoneDataType $phoneData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setPhoneData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\PhoneDataType $phoneData = null)
    {
        if (is_null($phoneData) || (is_array($phoneData) && empty($phoneData))) {
            unset($this->PhoneData);
        } else {
            $this->PhoneData = $phoneData;
        }
        return $this;
    }
    /**
     * Get PriceListCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPriceListCode()
    {
        return isset($this->PriceListCode) ? $this->PriceListCode : null;
    }
    /**
     * Set PriceListCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $priceListCode
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setPriceListCode($priceListCode = null)
    {
        // validation for constraint: string
        if (!is_null($priceListCode) && !is_string($priceListCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priceListCode, true), gettype($priceListCode)), __LINE__);
        }
        if (is_null($priceListCode) || (is_array($priceListCode) && empty($priceListCode))) {
            unset($this->PriceListCode);
        } else {
            $this->PriceListCode = $priceListCode;
        }
        return $this;
    }
    /**
     * Get RegionalRegistration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRegionalRegistration()
    {
        return isset($this->RegionalRegistration) ? $this->RegionalRegistration : null;
    }
    /**
     * Set RegionalRegistration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $regionalRegistration
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setRegionalRegistration($regionalRegistration = null)
    {
        // validation for constraint: string
        if (!is_null($regionalRegistration) && !is_string($regionalRegistration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($regionalRegistration, true), gettype($regionalRegistration)), __LINE__);
        }
        if (is_null($regionalRegistration) || (is_array($regionalRegistration) && empty($regionalRegistration))) {
            unset($this->RegionalRegistration);
        } else {
            $this->RegionalRegistration = $regionalRegistration;
        }
        return $this;
    }
    /**
     * Get RiskLevel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRiskLevel()
    {
        return isset($this->RiskLevel) ? $this->RiskLevel : null;
    }
    /**
     * Set RiskLevel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $riskLevel
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setRiskLevel($riskLevel = null)
    {
        // validation for constraint: string
        if (!is_null($riskLevel) && !is_string($riskLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($riskLevel, true), gettype($riskLevel)), __LINE__);
        }
        if (is_null($riskLevel) || (is_array($riskLevel) && empty($riskLevel))) {
            unset($this->RiskLevel);
        } else {
            $this->RiskLevel = $riskLevel;
        }
        return $this;
    }
    /**
     * Get SalesPerson2Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPerson2Id()
    {
        return isset($this->SalesPerson2Id) ? $this->SalesPerson2Id : null;
    }
    /**
     * Set SalesPerson2Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPerson2Id
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setSalesPerson2Id($salesPerson2Id = null)
    {
        // validation for constraint: string
        if (!is_null($salesPerson2Id) && !is_string($salesPerson2Id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPerson2Id, true), gettype($salesPerson2Id)), __LINE__);
        }
        if (is_null($salesPerson2Id) || (is_array($salesPerson2Id) && empty($salesPerson2Id))) {
            unset($this->SalesPerson2Id);
        } else {
            $this->SalesPerson2Id = $salesPerson2Id;
        }
        return $this;
    }
    /**
     * Get SalesPerson3Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPerson3Id()
    {
        return isset($this->SalesPerson3Id) ? $this->SalesPerson3Id : null;
    }
    /**
     * Set SalesPerson3Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPerson3Id
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setSalesPerson3Id($salesPerson3Id = null)
    {
        // validation for constraint: string
        if (!is_null($salesPerson3Id) && !is_string($salesPerson3Id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPerson3Id, true), gettype($salesPerson3Id)), __LINE__);
        }
        if (is_null($salesPerson3Id) || (is_array($salesPerson3Id) && empty($salesPerson3Id))) {
            unset($this->SalesPerson3Id);
        } else {
            $this->SalesPerson3Id = $salesPerson3Id;
        }
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get TitleId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitleId()
    {
        return isset($this->TitleId) ? $this->TitleId : null;
    }
    /**
     * Set TitleId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $titleId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setTitleId($titleId = null)
    {
        // validation for constraint: string
        if (!is_null($titleId) && !is_string($titleId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titleId, true), gettype($titleId)), __LINE__);
        }
        if (is_null($titleId) || (is_array($titleId) && empty($titleId))) {
            unset($this->TitleId);
        } else {
            $this->TitleId = $titleId;
        }
        return $this;
    }
    /**
     * Get UserDefinedBooleans value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean|null
     */
    public function getUserDefinedBooleans()
    {
        return isset($this->UserDefinedBooleans) ? $this->UserDefinedBooleans : null;
    }
    /**
     * Set UserDefinedBooleans value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean $userDefinedBooleans
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setUserDefinedBooleans(\FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean $userDefinedBooleans = null)
    {
        if (is_null($userDefinedBooleans) || (is_array($userDefinedBooleans) && empty($userDefinedBooleans))) {
            unset($this->UserDefinedBooleans);
        } else {
            $this->UserDefinedBooleans = $userDefinedBooleans;
        }
        return $this;
    }
    /**
     * Get UserDefinedData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType|null
     */
    public function getUserDefinedData()
    {
        return isset($this->UserDefinedData) ? $this->UserDefinedData : null;
    }
    /**
     * Set UserDefinedData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType $userDefinedData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setUserDefinedData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType $userDefinedData = null)
    {
        if (is_null($userDefinedData) || (is_array($userDefinedData) && empty($userDefinedData))) {
            unset($this->UserDefinedData);
        } else {
            $this->UserDefinedData = $userDefinedData;
        }
        return $this;
    }
    /**
     * Get UserDefinedDates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedDate|null
     */
    public function getUserDefinedDates()
    {
        return isset($this->UserDefinedDates) ? $this->UserDefinedDates : null;
    }
    /**
     * Set UserDefinedDates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setUserDefinedDates(\FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null)
    {
        if (is_null($userDefinedDates) || (is_array($userDefinedDates) && empty($userDefinedDates))) {
            unset($this->UserDefinedDates);
        } else {
            $this->UserDefinedDates = $userDefinedDates;
        }
        return $this;
    }
    /**
     * Get UserDefinedTexts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText|null
     */
    public function getUserDefinedTexts()
    {
        return isset($this->UserDefinedTexts) ? $this->UserDefinedTexts : null;
    }
    /**
     * Set UserDefinedTexts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText $userDefinedTexts
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setUserDefinedTexts(\FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedText $userDefinedTexts = null)
    {
        if (is_null($userDefinedTexts) || (is_array($userDefinedTexts) && empty($userDefinedTexts))) {
            unset($this->UserDefinedTexts);
        } else {
            $this->UserDefinedTexts = $userDefinedTexts;
        }
        return $this;
    }
    /**
     * Get UserDefinedValues value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue|null
     */
    public function getUserDefinedValues()
    {
        return isset($this->UserDefinedValues) ? $this->UserDefinedValues : null;
    }
    /**
     * Set UserDefinedValues value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue $userDefinedValues
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setUserDefinedValues(\FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue $userDefinedValues = null)
    {
        if (is_null($userDefinedValues) || (is_array($userDefinedValues) && empty($userDefinedValues))) {
            unset($this->UserDefinedValues);
        } else {
            $this->UserDefinedValues = $userDefinedValues;
        }
        return $this;
    }
    /**
     * Get UsualStoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUsualStoreId()
    {
        return isset($this->UsualStoreId) ? $this->UsualStoreId : null;
    }
    /**
     * Set UsualStoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $usualStoreId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public function setUsualStoreId($usualStoreId = null)
    {
        // validation for constraint: string
        if (!is_null($usualStoreId) && !is_string($usualStoreId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($usualStoreId, true), gettype($usualStoreId)), __LINE__);
        }
        if (is_null($usualStoreId) || (is_array($usualStoreId) && empty($usualStoreId))) {
            unset($this->UsualStoreId);
        } else {
            $this->UsualStoreId = $usualStoreId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerDataBase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
