<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerInputData StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: q62:CustomerInputData
 * @subpackage Structs
 */
class CustomerInputData extends CustomerData
{
    /**
     * The Closed
     * Meta information extracted from the WSDL
     * - documentation: [Added 2018/02 - V1400] [Optional] - Customer closed. - Related to column [TIERS.T_FERME].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $Closed;
    /**
     * The InvoiceCustomerId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Identifier of the invoiced customer associated with the customer. - Related to column [TIERS.T_FACTURE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InvoiceCustomerId;
    /**
     * The IsProspect
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/11 - V1201] [Optional] - Property specifying if the customer is a prospect. - Related to column [TIERS.T_NATUREAUXI].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsProspect;
    /**
     * The Notepad
     * Meta information extracted from the WSDL
     * - documentation: [Added 2018/02 - V1400] [Optional] - Notepad - Related to column [TIERS.T_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Notepad;
    /**
     * Constructor method for CustomerInputData
     * @uses CustomerInputData::setClosed()
     * @uses CustomerInputData::setInvoiceCustomerId()
     * @uses CustomerInputData::setIsProspect()
     * @uses CustomerInputData::setNotepad()
     * @param bool $closed
     * @param string $invoiceCustomerId
     * @param bool $isProspect
     * @param string $notepad
     */
    public function __construct($closed = null, $invoiceCustomerId = null, $isProspect = null, $notepad = null)
    {
        $this
            ->setClosed($closed)
            ->setInvoiceCustomerId($invoiceCustomerId)
            ->setIsProspect($isProspect)
            ->setNotepad($notepad);
    }
    /**
     * Get Closed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getClosed()
    {
        return isset($this->Closed) ? $this->Closed : null;
    }
    /**
     * Set Closed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $closed
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData
     */
    public function setClosed($closed = null)
    {
        // validation for constraint: boolean
        if (!is_null($closed) && !is_bool($closed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($closed, true), gettype($closed)), __LINE__);
        }
        if (is_null($closed) || (is_array($closed) && empty($closed))) {
            unset($this->Closed);
        } else {
            $this->Closed = $closed;
        }
        return $this;
    }
    /**
     * Get InvoiceCustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInvoiceCustomerId()
    {
        return isset($this->InvoiceCustomerId) ? $this->InvoiceCustomerId : null;
    }
    /**
     * Set InvoiceCustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $invoiceCustomerId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData
     */
    public function setInvoiceCustomerId($invoiceCustomerId = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceCustomerId) && !is_string($invoiceCustomerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceCustomerId, true), gettype($invoiceCustomerId)), __LINE__);
        }
        if (is_null($invoiceCustomerId) || (is_array($invoiceCustomerId) && empty($invoiceCustomerId))) {
            unset($this->InvoiceCustomerId);
        } else {
            $this->InvoiceCustomerId = $invoiceCustomerId;
        }
        return $this;
    }
    /**
     * Get IsProspect value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsProspect()
    {
        return isset($this->IsProspect) ? $this->IsProspect : null;
    }
    /**
     * Set IsProspect value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isProspect
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData
     */
    public function setIsProspect($isProspect = null)
    {
        // validation for constraint: boolean
        if (!is_null($isProspect) && !is_bool($isProspect)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isProspect, true), gettype($isProspect)), __LINE__);
        }
        if (is_null($isProspect) || (is_array($isProspect) && empty($isProspect))) {
            unset($this->IsProspect);
        } else {
            $this->IsProspect = $isProspect;
        }
        return $this;
    }
    /**
     * Get Notepad value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNotepad()
    {
        return isset($this->Notepad) ? $this->Notepad : null;
    }
    /**
     * Set Notepad value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $notepad
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData
     */
    public function setNotepad($notepad = null)
    {
        // validation for constraint: string
        if (!is_null($notepad) && !is_string($notepad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($notepad, true), gettype($notepad)), __LINE__);
        }
        if (is_null($notepad) || (is_array($notepad) && empty($notepad))) {
            unset($this->Notepad);
        } else {
            $this->Notepad = $notepad;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
