<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerSearchDataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Possible customer search criteria.
 * - nillable: true
 * - type: q52:CustomerSearchDataType
 * @subpackage Structs
 */
class CustomerSearchDataType extends CustomerDataBase
{
    /**
     * The ActivityCode
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Identifier of the customer's sales division. - Related to column [TIERS.T_APE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ActivityCode;
    /**
     * The Barcode
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Customer barcode. - Related to column [TIERS.T_EAN].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Barcode;
    /**
     * The BirthDateData
     * Meta information extracted from the WSDL
     * - documentation: Elements of the customer's birth date.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\BirthDateDataType
     */
    public $BirthDateData;
    /**
     * The Closed
     * Meta information extracted from the WSDL
     * - documentation: [Optional] - Customer closed. - Related to column [TIERS.T_FERME].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $Closed;
    /**
     * The CompanyIdNumber
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Customer's Company Registration Number. - Related to column [TIERS.T_SIRET].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CompanyIdNumber;
    /**
     * The CreationStoreId
     * Meta information extracted from the WSDL
     * - documentation: Identifier of the store where the customer was created. - Related to column [TIERS.T_ETABCREATION].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CreationStoreId;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: Customer identifier. - Related to column [TIERS.T_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The CustomerReference
     * Meta information extracted from the WSDL
     * - documentation: Search identifier based customer search priorities.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerReference;
    /**
     * The DirectMail
     * Meta information extracted from the WSDL
     * - documentation: [Added 2017/03 - V1110] [Optional] - Mail merge - Related to column [TIERS.T_PUBLIPOSTAGE].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $DirectMail;
    /**
     * The FiscalId
     * Meta information extracted from the WSDL
     * - documentation: Customer TIN or VAT identification number. - Related to column [TIERS.T_NIF].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FiscalId;
    /**
     * The InvoiceCustomerId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Identifier of the invoiced customer associated with the customer. - Related to column [TIERS.T_FACTURE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InvoiceCustomerId;
    /**
     * The IsCustomer
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/11 - V1201] [Optional] - Customer. - Related to column [TIERS.T_NATUREAUXI].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsCustomer;
    /**
     * The IsProspect
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/11 - V1201] [Optional] - Prospect. - Related to column [TIERS.T_NATUREAUXI].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsProspect;
    /**
     * The ItalianFiscalId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/03 - V1201] [Optional] - Customer fiscal identifier for Italian tax administration. - Related to column [TIERSCOMPL.YTC_CODEFISCIT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ItalianFiscalId;
    /**
     * The MaxNumberOfCustomers
     * Meta information extracted from the WSDL
     * - documentation: [Added 2014/08 - V1105] [Optional] - Maximum number of customers returned. If not specified, maximum 5 customers are returned.
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $MaxNumberOfCustomers;
    /**
     * The NationalityData
     * Meta information extracted from the WSDL
     * - documentation: Customer's nationality data.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\NationalityDataType
     */
    public $NationalityData;
    /**
     * The PassportNumber
     * Meta information extracted from the WSDL
     * - documentation: Customer's passport. - Related to column [TIERS.T_PASSEPORT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PassportNumber;
    /**
     * Constructor method for CustomerSearchDataType
     * @uses CustomerSearchDataType::setActivityCode()
     * @uses CustomerSearchDataType::setBarcode()
     * @uses CustomerSearchDataType::setBirthDateData()
     * @uses CustomerSearchDataType::setClosed()
     * @uses CustomerSearchDataType::setCompanyIdNumber()
     * @uses CustomerSearchDataType::setCreationStoreId()
     * @uses CustomerSearchDataType::setCustomerId()
     * @uses CustomerSearchDataType::setCustomerReference()
     * @uses CustomerSearchDataType::setDirectMail()
     * @uses CustomerSearchDataType::setFiscalId()
     * @uses CustomerSearchDataType::setInvoiceCustomerId()
     * @uses CustomerSearchDataType::setIsCustomer()
     * @uses CustomerSearchDataType::setIsProspect()
     * @uses CustomerSearchDataType::setItalianFiscalId()
     * @uses CustomerSearchDataType::setMaxNumberOfCustomers()
     * @uses CustomerSearchDataType::setNationalityData()
     * @uses CustomerSearchDataType::setPassportNumber()
     * @param string $activityCode
     * @param string $barcode
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\BirthDateDataType $birthDateData
     * @param bool $closed
     * @param string $companyIdNumber
     * @param string $creationStoreId
     * @param string $customerId
     * @param string $customerReference
     * @param bool $directMail
     * @param string $fiscalId
     * @param string $invoiceCustomerId
     * @param bool $isCustomer
     * @param bool $isProspect
     * @param string $italianFiscalId
     * @param int $maxNumberOfCustomers
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\NationalityDataType $nationalityData
     * @param string $passportNumber
     */
    public function __construct($activityCode = null, $barcode = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\BirthDateDataType $birthDateData = null, $closed = null, $companyIdNumber = null, $creationStoreId = null, $customerId = null, $customerReference = null, $directMail = null, $fiscalId = null, $invoiceCustomerId = null, $isCustomer = null, $isProspect = null, $italianFiscalId = null, $maxNumberOfCustomers = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\NationalityDataType $nationalityData = null, $passportNumber = null)
    {
        $this
            ->setActivityCode($activityCode)
            ->setBarcode($barcode)
            ->setBirthDateData($birthDateData)
            ->setClosed($closed)
            ->setCompanyIdNumber($companyIdNumber)
            ->setCreationStoreId($creationStoreId)
            ->setCustomerId($customerId)
            ->setCustomerReference($customerReference)
            ->setDirectMail($directMail)
            ->setFiscalId($fiscalId)
            ->setInvoiceCustomerId($invoiceCustomerId)
            ->setIsCustomer($isCustomer)
            ->setIsProspect($isProspect)
            ->setItalianFiscalId($italianFiscalId)
            ->setMaxNumberOfCustomers($maxNumberOfCustomers)
            ->setNationalityData($nationalityData)
            ->setPassportNumber($passportNumber);
    }
    /**
     * Get ActivityCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getActivityCode()
    {
        return isset($this->ActivityCode) ? $this->ActivityCode : null;
    }
    /**
     * Set ActivityCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $activityCode
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setActivityCode($activityCode = null)
    {
        // validation for constraint: string
        if (!is_null($activityCode) && !is_string($activityCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($activityCode, true), gettype($activityCode)), __LINE__);
        }
        if (is_null($activityCode) || (is_array($activityCode) && empty($activityCode))) {
            unset($this->ActivityCode);
        } else {
            $this->ActivityCode = $activityCode;
        }
        return $this;
    }
    /**
     * Get Barcode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBarcode()
    {
        return isset($this->Barcode) ? $this->Barcode : null;
    }
    /**
     * Set Barcode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $barcode
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setBarcode($barcode = null)
    {
        // validation for constraint: string
        if (!is_null($barcode) && !is_string($barcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($barcode, true), gettype($barcode)), __LINE__);
        }
        if (is_null($barcode) || (is_array($barcode) && empty($barcode))) {
            unset($this->Barcode);
        } else {
            $this->Barcode = $barcode;
        }
        return $this;
    }
    /**
     * Get BirthDateData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\BirthDateDataType|null
     */
    public function getBirthDateData()
    {
        return isset($this->BirthDateData) ? $this->BirthDateData : null;
    }
    /**
     * Set BirthDateData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\BirthDateDataType $birthDateData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setBirthDateData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\BirthDateDataType $birthDateData = null)
    {
        if (is_null($birthDateData) || (is_array($birthDateData) && empty($birthDateData))) {
            unset($this->BirthDateData);
        } else {
            $this->BirthDateData = $birthDateData;
        }
        return $this;
    }
    /**
     * Get Closed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getClosed()
    {
        return isset($this->Closed) ? $this->Closed : null;
    }
    /**
     * Set Closed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $closed
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setClosed($closed = null)
    {
        // validation for constraint: boolean
        if (!is_null($closed) && !is_bool($closed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($closed, true), gettype($closed)), __LINE__);
        }
        if (is_null($closed) || (is_array($closed) && empty($closed))) {
            unset($this->Closed);
        } else {
            $this->Closed = $closed;
        }
        return $this;
    }
    /**
     * Get CompanyIdNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCompanyIdNumber()
    {
        return isset($this->CompanyIdNumber) ? $this->CompanyIdNumber : null;
    }
    /**
     * Set CompanyIdNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $companyIdNumber
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setCompanyIdNumber($companyIdNumber = null)
    {
        // validation for constraint: string
        if (!is_null($companyIdNumber) && !is_string($companyIdNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($companyIdNumber, true), gettype($companyIdNumber)), __LINE__);
        }
        if (is_null($companyIdNumber) || (is_array($companyIdNumber) && empty($companyIdNumber))) {
            unset($this->CompanyIdNumber);
        } else {
            $this->CompanyIdNumber = $companyIdNumber;
        }
        return $this;
    }
    /**
     * Get CreationStoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCreationStoreId()
    {
        return isset($this->CreationStoreId) ? $this->CreationStoreId : null;
    }
    /**
     * Set CreationStoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $creationStoreId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setCreationStoreId($creationStoreId = null)
    {
        // validation for constraint: string
        if (!is_null($creationStoreId) && !is_string($creationStoreId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($creationStoreId, true), gettype($creationStoreId)), __LINE__);
        }
        if (is_null($creationStoreId) || (is_array($creationStoreId) && empty($creationStoreId))) {
            unset($this->CreationStoreId);
        } else {
            $this->CreationStoreId = $creationStoreId;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get CustomerReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerReference()
    {
        return isset($this->CustomerReference) ? $this->CustomerReference : null;
    }
    /**
     * Set CustomerReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerReference
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setCustomerReference($customerReference = null)
    {
        // validation for constraint: string
        if (!is_null($customerReference) && !is_string($customerReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerReference, true), gettype($customerReference)), __LINE__);
        }
        if (is_null($customerReference) || (is_array($customerReference) && empty($customerReference))) {
            unset($this->CustomerReference);
        } else {
            $this->CustomerReference = $customerReference;
        }
        return $this;
    }
    /**
     * Get DirectMail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getDirectMail()
    {
        return isset($this->DirectMail) ? $this->DirectMail : null;
    }
    /**
     * Set DirectMail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $directMail
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setDirectMail($directMail = null)
    {
        // validation for constraint: boolean
        if (!is_null($directMail) && !is_bool($directMail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($directMail, true), gettype($directMail)), __LINE__);
        }
        if (is_null($directMail) || (is_array($directMail) && empty($directMail))) {
            unset($this->DirectMail);
        } else {
            $this->DirectMail = $directMail;
        }
        return $this;
    }
    /**
     * Get FiscalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFiscalId()
    {
        return isset($this->FiscalId) ? $this->FiscalId : null;
    }
    /**
     * Set FiscalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fiscalId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setFiscalId($fiscalId = null)
    {
        // validation for constraint: string
        if (!is_null($fiscalId) && !is_string($fiscalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fiscalId, true), gettype($fiscalId)), __LINE__);
        }
        if (is_null($fiscalId) || (is_array($fiscalId) && empty($fiscalId))) {
            unset($this->FiscalId);
        } else {
            $this->FiscalId = $fiscalId;
        }
        return $this;
    }
    /**
     * Get InvoiceCustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInvoiceCustomerId()
    {
        return isset($this->InvoiceCustomerId) ? $this->InvoiceCustomerId : null;
    }
    /**
     * Set InvoiceCustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $invoiceCustomerId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setInvoiceCustomerId($invoiceCustomerId = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceCustomerId) && !is_string($invoiceCustomerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceCustomerId, true), gettype($invoiceCustomerId)), __LINE__);
        }
        if (is_null($invoiceCustomerId) || (is_array($invoiceCustomerId) && empty($invoiceCustomerId))) {
            unset($this->InvoiceCustomerId);
        } else {
            $this->InvoiceCustomerId = $invoiceCustomerId;
        }
        return $this;
    }
    /**
     * Get IsCustomer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsCustomer()
    {
        return isset($this->IsCustomer) ? $this->IsCustomer : null;
    }
    /**
     * Set IsCustomer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isCustomer
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setIsCustomer($isCustomer = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCustomer) && !is_bool($isCustomer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCustomer, true), gettype($isCustomer)), __LINE__);
        }
        if (is_null($isCustomer) || (is_array($isCustomer) && empty($isCustomer))) {
            unset($this->IsCustomer);
        } else {
            $this->IsCustomer = $isCustomer;
        }
        return $this;
    }
    /**
     * Get IsProspect value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsProspect()
    {
        return isset($this->IsProspect) ? $this->IsProspect : null;
    }
    /**
     * Set IsProspect value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isProspect
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setIsProspect($isProspect = null)
    {
        // validation for constraint: boolean
        if (!is_null($isProspect) && !is_bool($isProspect)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isProspect, true), gettype($isProspect)), __LINE__);
        }
        if (is_null($isProspect) || (is_array($isProspect) && empty($isProspect))) {
            unset($this->IsProspect);
        } else {
            $this->IsProspect = $isProspect;
        }
        return $this;
    }
    /**
     * Get ItalianFiscalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getItalianFiscalId()
    {
        return isset($this->ItalianFiscalId) ? $this->ItalianFiscalId : null;
    }
    /**
     * Set ItalianFiscalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $italianFiscalId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setItalianFiscalId($italianFiscalId = null)
    {
        // validation for constraint: string
        if (!is_null($italianFiscalId) && !is_string($italianFiscalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($italianFiscalId, true), gettype($italianFiscalId)), __LINE__);
        }
        if (is_null($italianFiscalId) || (is_array($italianFiscalId) && empty($italianFiscalId))) {
            unset($this->ItalianFiscalId);
        } else {
            $this->ItalianFiscalId = $italianFiscalId;
        }
        return $this;
    }
    /**
     * Get MaxNumberOfCustomers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getMaxNumberOfCustomers()
    {
        return isset($this->MaxNumberOfCustomers) ? $this->MaxNumberOfCustomers : null;
    }
    /**
     * Set MaxNumberOfCustomers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $maxNumberOfCustomers
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setMaxNumberOfCustomers($maxNumberOfCustomers = null)
    {
        // validation for constraint: int
        if (!is_null($maxNumberOfCustomers) && !(is_int($maxNumberOfCustomers) || ctype_digit($maxNumberOfCustomers))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxNumberOfCustomers, true), gettype($maxNumberOfCustomers)), __LINE__);
        }
        if (is_null($maxNumberOfCustomers) || (is_array($maxNumberOfCustomers) && empty($maxNumberOfCustomers))) {
            unset($this->MaxNumberOfCustomers);
        } else {
            $this->MaxNumberOfCustomers = $maxNumberOfCustomers;
        }
        return $this;
    }
    /**
     * Get NationalityData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\NationalityDataType|null
     */
    public function getNationalityData()
    {
        return isset($this->NationalityData) ? $this->NationalityData : null;
    }
    /**
     * Set NationalityData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\NationalityDataType $nationalityData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setNationalityData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\NationalityDataType $nationalityData = null)
    {
        if (is_null($nationalityData) || (is_array($nationalityData) && empty($nationalityData))) {
            unset($this->NationalityData);
        } else {
            $this->NationalityData = $nationalityData;
        }
        return $this;
    }
    /**
     * Get PassportNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPassportNumber()
    {
        return isset($this->PassportNumber) ? $this->PassportNumber : null;
    }
    /**
     * Set PassportNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $passportNumber
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public function setPassportNumber($passportNumber = null)
    {
        // validation for constraint: string
        if (!is_null($passportNumber) && !is_string($passportNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($passportNumber, true), gettype($passportNumber)), __LINE__);
        }
        if (is_null($passportNumber) || (is_array($passportNumber) && empty($passportNumber))) {
            unset($this->PassportNumber);
        } else {
            $this->PassportNumber = $passportNumber;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
