<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\EnumType;

/**
 * This class stands for QueryExecutionStatus EnumType
 * Meta information extracted from the WSDL
 * - documentation: Possible return codes of the search function for the main warehouse of a store.
 * - nillable: true
 * - type: tns:QueryExecutionStatus
 * @subpackage Enumerations
 */
class QueryExecutionStatus
{
    /**
     * Constant for value 'Ok'
     * Meta information extracted from the WSDL
     * - documentation: Search was running well, warehouse found.
     * @return string 'Ok'
     */
    const VALUE_OK = 'Ok';
    /**
     * Constant for value 'IncorrectWarehouseId'
     * Meta information extracted from the WSDL
     * - documentation: Wrong warehouse code.
     * @return string 'IncorrectWarehouseId'
     */
    const VALUE_INCORRECT_WAREHOUSE_ID = 'IncorrectWarehouseId';
    /**
     * Constant for value 'IncorrectStoreId'
     * Meta information extracted from the WSDL
     * - documentation: Wrong store code.
     * @return string 'IncorrectStoreId'
     */
    const VALUE_INCORRECT_STORE_ID = 'IncorrectStoreId';
    /**
     * Constant for value 'StoreNotFound'
     * Meta information extracted from the WSDL
     * - documentation: Store unknown.
     * @return string 'StoreNotFound'
     */
    const VALUE_STORE_NOT_FOUND = 'StoreNotFound';
    /**
     * Constant for value 'Unknown'
     * Meta information extracted from the WSDL
     * - documentation: Undefined, error without functional explanation.
     * @return string 'Unknown'
     */
    const VALUE_UNKNOWN = 'Unknown';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_OK
     * @uses self::VALUE_INCORRECT_WAREHOUSE_ID
     * @uses self::VALUE_INCORRECT_STORE_ID
     * @uses self::VALUE_STORE_NOT_FOUND
     * @uses self::VALUE_UNKNOWN
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_OK,
            self::VALUE_INCORRECT_WAREHOUSE_ID,
            self::VALUE_INCORRECT_STORE_ID,
            self::VALUE_STORE_NOT_FOUND,
            self::VALUE_UNKNOWN,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
