<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Pager StructType
 * Meta information extracted from the WSDL
 * - documentation: Object for page management. 1st page: PageSize = 50, PageIndex = 1 - 2nd page: PageSize = 50, PageIndex = 2"
 * - nillable: true
 * - type: tns:Pager
 * @subpackage Structs
 */
class Pager extends AbstractStructBase
{
    /**
     * The PageIndex
     * Meta information extracted from the WSDL
     * - documentation: [Optional] - Page index to return. 1 by default. - Default value: 1.
     * - minOccurs: 0
     * @var int
     */
    public $PageIndex;
    /**
     * The PageSize
     * Meta information extracted from the WSDL
     * - documentation: [Optional] - Maximum number of lines to return per page. - Default value: 20.
     * - minOccurs: 0
     * @var int
     */
    public $PageSize;
    /**
     * Constructor method for Pager
     * @uses Pager::setPageIndex()
     * @uses Pager::setPageSize()
     * @param int $pageIndex
     * @param int $pageSize
     */
    public function __construct($pageIndex = null, $pageSize = null)
    {
        $this
            ->setPageIndex($pageIndex)
            ->setPageSize($pageSize);
    }
    /**
     * Get PageIndex value
     * @return int|null
     */
    public function getPageIndex()
    {
        return $this->PageIndex;
    }
    /**
     * Set PageIndex value
     * @param int $pageIndex
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager
     */
    public function setPageIndex($pageIndex = null)
    {
        // validation for constraint: int
        if (!is_null($pageIndex) && !(is_int($pageIndex) || ctype_digit($pageIndex))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pageIndex, true), gettype($pageIndex)), __LINE__);
        }
        $this->PageIndex = $pageIndex;
        return $this;
    }
    /**
     * Get PageSize value
     * @return int|null
     */
    public function getPageSize()
    {
        return $this->PageSize;
    }
    /**
     * Set PageSize value
     * @param int $pageSize
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager
     */
    public function setPageSize($pageSize = null)
    {
        // validation for constraint: int
        if (!is_null($pageSize) && !(is_int($pageSize) || ctype_digit($pageSize))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pageSize, true), gettype($pageSize)), __LINE__);
        }
        $this->PageSize = $pageSize;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
