<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType;

/**
 * This class stands for LoyaltyProgramType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Data combos of loyalty programs
 * - nillable: true
 * - type: tns:LoyaltyProgramType
 * @subpackage Enumerations
 */
class LoyaltyProgramType
{
    /**
     * Constant for value 'Unlimited'
     * Meta information extracted from the WSDL
     * - documentation: Unlimited.
     * @return string 'Unlimited'
     */
    const VALUE_UNLIMITED = 'Unlimited';
    /**
     * Constant for value 'ByEndDate'
     * Meta information extracted from the WSDL
     * - documentation: End date.
     * @return string 'ByEndDate'
     */
    const VALUE_BY_END_DATE = 'ByEndDate';
    /**
     * Constant for value 'ByDayNumber'
     * Meta information extracted from the WSDL
     * - documentation: Number of days.
     * @return string 'ByDayNumber'
     */
    const VALUE_BY_DAY_NUMBER = 'ByDayNumber';
    /**
     * Constant for value 'ByAmount'
     * Meta information extracted from the WSDL
     * - documentation: Amount.
     * @return string 'ByAmount'
     */
    const VALUE_BY_AMOUNT = 'ByAmount';
    /**
     * Constant for value 'ByPoints'
     * Meta information extracted from the WSDL
     * - documentation: Points.
     * @return string 'ByPoints'
     */
    const VALUE_BY_POINTS = 'ByPoints';
    /**
     * Constant for value 'DeductionThreshold'
     * Meta information extracted from the WSDL
     * - documentation: Threshold deduction.
     * @return string 'DeductionThreshold'
     */
    const VALUE_DEDUCTION_THRESHOLD = 'DeductionThreshold';
    /**
     * Constant for value 'GlobalRaz'
     * Meta information extracted from the WSDL
     * - documentation: Global reset.
     * @return string 'GlobalRaz'
     */
    const VALUE_GLOBAL_RAZ = 'GlobalRaz';
    /**
     * Constant for value 'RazBeforeBenefitTicket'
     * Meta information extracted from the WSDL
     * - documentation: RTZ before benefit receipt.
     * @return string 'RazBeforeBenefitTicket'
     */
    const VALUE_RAZ_BEFORE_BENEFIT_TICKET = 'RazBeforeBenefitTicket';
    /**
     * Constant for value 'DiscountOrGift'
     * Meta information extracted from the WSDL
     * - documentation: Discount or gift.
     * @return string 'DiscountOrGift'
     */
    const VALUE_DISCOUNT_OR_GIFT = 'DiscountOrGift';
    /**
     * Constant for value 'Payment'
     * Meta information extracted from the WSDL
     * - documentation: Payment method.
     * @return string 'Payment'
     */
    const VALUE_PAYMENT = 'Payment';
    /**
     * Constant for value 'Without'
     * Meta information extracted from the WSDL
     * - documentation: Without.
     * @return string 'Without'
     */
    const VALUE_WITHOUT = 'Without';
    /**
     * Constant for value 'CentralVoucher'
     * Meta information extracted from the WSDL
     * - documentation: Gift certificates from Headquarters.
     * @return string 'CentralVoucher'
     */
    const VALUE_CENTRAL_VOUCHER = 'CentralVoucher';
    /**
     * Constant for value 'CashRegisterVoucher'
     * Meta information extracted from the WSDL
     * - documentation: Gift certificates on the register.
     * @return string 'CashRegisterVoucher'
     */
    const VALUE_CASH_REGISTER_VOUCHER = 'CashRegisterVoucher';
    /**
     * Constant for value 'CentralVoucher_or_CashRegisterVoucher'
     * Meta information extracted from the WSDL
     * - documentation: Gift certificates from Headquarters or register.
     * @return string 'CentralVoucher_or_CashRegisterVoucher'
     */
    const VALUE_CENTRAL_VOUCHER_OR_CASH_REGISTER_VOUCHER = 'CentralVoucher_or_CashRegisterVoucher';
    /**
     * Constant for value 'Automatic'
     * Meta information extracted from the WSDL
     * - documentation: Automatic.
     * @return string 'Automatic'
     */
    const VALUE_AUTOMATIC = 'Automatic';
    /**
     * Constant for value 'OnDemand'
     * Meta information extracted from the WSDL
     * - documentation: On request.
     * @return string 'OnDemand'
     */
    const VALUE_ON_DEMAND = 'OnDemand';
    /**
     * Constant for value 'OnStartingRules'
     * Meta information extracted from the WSDL
     * - documentation: On startup rules.
     * @return string 'OnStartingRules'
     */
    const VALUE_ON_STARTING_RULES = 'OnStartingRules';
    /**
     * Constant for value 'Discount'
     * Meta information extracted from the WSDL
     * - documentation: Discount.
     * @return string 'Discount'
     */
    const VALUE_DISCOUNT = 'Discount';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_UNLIMITED
     * @uses self::VALUE_BY_END_DATE
     * @uses self::VALUE_BY_DAY_NUMBER
     * @uses self::VALUE_BY_AMOUNT
     * @uses self::VALUE_BY_POINTS
     * @uses self::VALUE_DEDUCTION_THRESHOLD
     * @uses self::VALUE_GLOBAL_RAZ
     * @uses self::VALUE_RAZ_BEFORE_BENEFIT_TICKET
     * @uses self::VALUE_DISCOUNT_OR_GIFT
     * @uses self::VALUE_PAYMENT
     * @uses self::VALUE_WITHOUT
     * @uses self::VALUE_CENTRAL_VOUCHER
     * @uses self::VALUE_CASH_REGISTER_VOUCHER
     * @uses self::VALUE_CENTRAL_VOUCHER_OR_CASH_REGISTER_VOUCHER
     * @uses self::VALUE_AUTOMATIC
     * @uses self::VALUE_ON_DEMAND
     * @uses self::VALUE_ON_STARTING_RULES
     * @uses self::VALUE_DISCOUNT
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_UNLIMITED,
            self::VALUE_BY_END_DATE,
            self::VALUE_BY_DAY_NUMBER,
            self::VALUE_BY_AMOUNT,
            self::VALUE_BY_POINTS,
            self::VALUE_DEDUCTION_THRESHOLD,
            self::VALUE_GLOBAL_RAZ,
            self::VALUE_RAZ_BEFORE_BENEFIT_TICKET,
            self::VALUE_DISCOUNT_OR_GIFT,
            self::VALUE_PAYMENT,
            self::VALUE_WITHOUT,
            self::VALUE_CENTRAL_VOUCHER,
            self::VALUE_CASH_REGISTER_VOUCHER,
            self::VALUE_CENTRAL_VOUCHER_OR_CASH_REGISTER_VOUCHER,
            self::VALUE_AUTOMATIC,
            self::VALUE_ON_DEMAND,
            self::VALUE_ON_STARTING_RULES,
            self::VALUE_DISCOUNT,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
