<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateExternCardRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Creation of a loyalty card from an external system
 * - nillable: true
 * - type: tns:CreateExternCardRequest
 * @subpackage Structs
 */
class CreateExternCardRequest extends AbstractStructBase
{
    /**
     * The Closed
     * Meta information extracted from the WSDL
     * - documentation: Loyalty card closed - Related to column [MCARTEFIDENT.MFC_FERME].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $Closed;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: Customer identifier - Related to column [MCARTEFIDENT.MFC_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The LoyaltyCardId
     * Meta information extracted from the WSDL
     * - documentation: Loyalty card number - Related to column [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoyaltyCardId;
    /**
     * The ProgramId
     * Meta information extracted from the WSDL
     * - documentation: Loyalty program identifier - Related to column [MCARTEFIDENT.MFC_PROGFIDELITE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ProgramId;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Store identifier - Related to column [MCARTEFIDENT.MFC_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * The ValidityPeriod
     * Meta information extracted from the WSDL
     * - documentation: Validity dates for the loyalty card.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType
     */
    public $ValidityPeriod;
    /**
     * Constructor method for CreateExternCardRequest
     * @uses CreateExternCardRequest::setClosed()
     * @uses CreateExternCardRequest::setCustomerId()
     * @uses CreateExternCardRequest::setLoyaltyCardId()
     * @uses CreateExternCardRequest::setProgramId()
     * @uses CreateExternCardRequest::setStoreId()
     * @uses CreateExternCardRequest::setValidityPeriod()
     * @param bool $closed
     * @param string $customerId
     * @param string $loyaltyCardId
     * @param string $programId
     * @param string $storeId
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod
     */
    public function __construct($closed = null, $customerId = null, $loyaltyCardId = null, $programId = null, $storeId = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod = null)
    {
        $this
            ->setClosed($closed)
            ->setCustomerId($customerId)
            ->setLoyaltyCardId($loyaltyCardId)
            ->setProgramId($programId)
            ->setStoreId($storeId)
            ->setValidityPeriod($validityPeriod);
    }
    /**
     * Get Closed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getClosed()
    {
        return isset($this->Closed) ? $this->Closed : null;
    }
    /**
     * Set Closed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $closed
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public function setClosed($closed = null)
    {
        // validation for constraint: boolean
        if (!is_null($closed) && !is_bool($closed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($closed, true), gettype($closed)), __LINE__);
        }
        if (is_null($closed) || (is_array($closed) && empty($closed))) {
            unset($this->Closed);
        } else {
            $this->Closed = $closed;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get LoyaltyCardId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoyaltyCardId()
    {
        return isset($this->LoyaltyCardId) ? $this->LoyaltyCardId : null;
    }
    /**
     * Set LoyaltyCardId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loyaltyCardId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public function setLoyaltyCardId($loyaltyCardId = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyCardId) && !is_string($loyaltyCardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loyaltyCardId, true), gettype($loyaltyCardId)), __LINE__);
        }
        if (is_null($loyaltyCardId) || (is_array($loyaltyCardId) && empty($loyaltyCardId))) {
            unset($this->LoyaltyCardId);
        } else {
            $this->LoyaltyCardId = $loyaltyCardId;
        }
        return $this;
    }
    /**
     * Get ProgramId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProgramId()
    {
        return isset($this->ProgramId) ? $this->ProgramId : null;
    }
    /**
     * Set ProgramId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $programId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public function setProgramId($programId = null)
    {
        // validation for constraint: string
        if (!is_null($programId) && !is_string($programId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($programId, true), gettype($programId)), __LINE__);
        }
        if (is_null($programId) || (is_array($programId) && empty($programId))) {
            unset($this->ProgramId);
        } else {
            $this->ProgramId = $programId;
        }
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Get ValidityPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType|null
     */
    public function getValidityPeriod()
    {
        return isset($this->ValidityPeriod) ? $this->ValidityPeriod : null;
    }
    /**
     * Set ValidityPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public function setValidityPeriod(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod = null)
    {
        if (is_null($validityPeriod) || (is_array($validityPeriod) && empty($validityPeriod))) {
            unset($this->ValidityPeriod);
        } else {
            $this->ValidityPeriod = $validityPeriod;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
