<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateLoyaltyCard StructType
 * Meta information extracted from the WSDL
 * - documentation: Enables the creation of a loyalty card.
 * @subpackage Structs
 */
class CreateLoyaltyCard extends AbstractStructBase
{
    /**
     * The customerReference
     * Meta information extracted from the WSDL
     * - documentation: Reference enabling the identification of the customer. - Related to column [MCARETFIDENT.MFC_TIERS]
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $customerReference;
    /**
     * The storeId
     * Meta information extracted from the WSDL
     * - documentation: Store identifier. - Related to column [MCARETFIDENT.MFC_ETABLISSEMENT]
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $storeId;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for CreateLoyaltyCard
     * @uses CreateLoyaltyCard::setCustomerReference()
     * @uses CreateLoyaltyCard::setStoreId()
     * @uses CreateLoyaltyCard::setClientContext()
     * @param string $customerReference
     * @param string $storeId
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     */
    public function __construct($customerReference = null, $storeId = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setCustomerReference($customerReference)
            ->setStoreId($storeId)
            ->setClientContext($clientContext);
    }
    /**
     * Get customerReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerReference()
    {
        return isset($this->customerReference) ? $this->customerReference : null;
    }
    /**
     * Set customerReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerReference
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCard
     */
    public function setCustomerReference($customerReference = null)
    {
        // validation for constraint: string
        if (!is_null($customerReference) && !is_string($customerReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerReference, true), gettype($customerReference)), __LINE__);
        }
        if (is_null($customerReference) || (is_array($customerReference) && empty($customerReference))) {
            unset($this->customerReference);
        } else {
            $this->customerReference = $customerReference;
        }
        return $this;
    }
    /**
     * Get storeId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->storeId) ? $this->storeId : null;
    }
    /**
     * Set storeId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCard
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->storeId);
        } else {
            $this->storeId = $storeId;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCard
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
