<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaleDocumentIdentifier StructType
 * Meta information extracted from the WSDL
 * - documentation: Identification criteria of a sales document: provide either 'Key' or 'Reference' to find a document respectively via its key or reference
 * - nillable: true
 * - type: tns:SaleDocumentIdentifier
 * @subpackage Structs
 */
class SaleDocumentIdentifier extends AbstractStructBase
{
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey
     */
    public $Key;
    /**
     * The Reference
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/08].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentReference
     */
    public $Reference;
    /**
     * Constructor method for SaleDocumentIdentifier
     * @uses SaleDocumentIdentifier::setKey()
     * @uses SaleDocumentIdentifier::setReference()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey $key
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentReference $reference
     */
    public function __construct(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey $key = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentReference $reference = null)
    {
        $this
            ->setKey($key)
            ->setReference($reference);
    }
    /**
     * Get Key value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey|null
     */
    public function getKey()
    {
        return isset($this->Key) ? $this->Key : null;
    }
    /**
     * Set Key value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey $key
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier
     */
    public function setKey(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey $key = null)
    {
        if (is_null($key) || (is_array($key) && empty($key))) {
            unset($this->Key);
        } else {
            $this->Key = $key;
        }
        return $this;
    }
    /**
     * Get Reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentReference|null
     */
    public function getReference()
    {
        return isset($this->Reference) ? $this->Reference : null;
    }
    /**
     * Set Reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentReference $reference
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier
     */
    public function setReference(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentReference $reference = null)
    {
        if (is_null($reference) || (is_array($reference) && empty($reference))) {
            unset($this->Reference);
        } else {
            $this->Reference = $reference;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
