<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGet_Payment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGet_Payment
 * @subpackage Arrays
 */
class ArrayOfGet_Payment extends AbstractStructArrayBase
{
    /**
     * The Get_Payment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment[]
     */
    public $Get_Payment;
    /**
     * Constructor method for ArrayOfGet_Payment
     * @uses ArrayOfGet_Payment::setGet_Payment()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment[] $get_Payment
     */
    public function __construct(array $get_Payment = array())
    {
        $this
            ->setGet_Payment($get_Payment);
    }
    /**
     * Get Get_Payment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment[]|null
     */
    public function getGet_Payment()
    {
        return isset($this->Get_Payment) ? $this->Get_Payment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGet_Payment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGet_Payment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGet_PaymentForArrayConstraintsFromSetGet_Payment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGet_PaymentGet_PaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfGet_PaymentGet_PaymentItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment) {
                $invalidValues[] = is_object($arrayOfGet_PaymentGet_PaymentItem) ? get_class($arrayOfGet_PaymentGet_PaymentItem) : sprintf('%s(%s)', gettype($arrayOfGet_PaymentGet_PaymentItem), var_export($arrayOfGet_PaymentGet_PaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Get_Payment property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Get_Payment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment[] $get_Payment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Payment
     */
    public function setGet_Payment(array $get_Payment = array())
    {
        // validation for constraint: array
        if ('' !== ($get_PaymentArrayErrorMessage = self::validateGet_PaymentForArrayConstraintsFromSetGet_Payment($get_Payment))) {
            throw new \InvalidArgumentException($get_PaymentArrayErrorMessage, __LINE__);
        }
        if (is_null($get_Payment) || (is_array($get_Payment) && empty($get_Payment))) {
            unset($this->Get_Payment);
        } else {
            $this->Get_Payment = $get_Payment;
        }
        return $this;
    }
    /**
     * Add item to Get_Payment value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Payment
     */
    public function addToGet_Payment(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment) {
            throw new \InvalidArgumentException(sprintf('The Get_Payment property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Get_Payment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Get_Payment
     */
    public function getAttributeName()
    {
        return 'Get_Payment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Payment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
