<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for DocumentStatus EnumType
 * Meta information extracted from the WSDL
 * - documentation: Document status
 * - nillable: true
 * - type: tns:DocumentStatus
 * @subpackage Enumerations
 */
class DocumentStatus
{
    /**
     * Constant for value 'Canceled'
     * Meta information extracted from the WSDL
     * - documentation: Canceled.
     * @return string 'Canceled'
     */
    const VALUE_CANCELED = 'Canceled';
    /**
     * Constant for value 'None'
     * Meta information extracted from the WSDL
     * - documentation: None.
     * @return string 'None'
     */
    const VALUE_NONE = 'None';
    /**
     * Constant for value 'InProgress'
     * Meta information extracted from the WSDL
     * - documentation: In progress.
     * @return string 'InProgress'
     */
    const VALUE_IN_PROGRESS = 'InProgress';
    /**
     * Constant for value 'Delivered'
     * Meta information extracted from the WSDL
     * - documentation: Delivered.
     * @return string 'Delivered'
     */
    const VALUE_DELIVERED = 'Delivered';
    /**
     * Constant for value 'NotRecovered'
     * Meta information extracted from the WSDL
     * - documentation: Not recovered.
     * @return string 'NotRecovered'
     */
    const VALUE_NOT_RECOVERED = 'NotRecovered';
    /**
     * Constant for value 'Recovered'
     * Meta information extracted from the WSDL
     * - documentation: Recovered.
     * @return string 'Recovered'
     */
    const VALUE_RECOVERED = 'Recovered';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_CANCELED
     * @uses self::VALUE_NONE
     * @uses self::VALUE_IN_PROGRESS
     * @uses self::VALUE_DELIVERED
     * @uses self::VALUE_NOT_RECOVERED
     * @uses self::VALUE_RECOVERED
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_CANCELED,
            self::VALUE_NONE,
            self::VALUE_IN_PROGRESS,
            self::VALUE_DELIVERED,
            self::VALUE_NOT_RECOVERED,
            self::VALUE_RECOVERED,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
