<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for GiftMessageType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Gift card type
 * - nillable: true
 * - type: tns:GiftMessageType
 * @subpackage Enumerations
 */
class GiftMessageType
{
    /**
     * Constant for value 'None'
     * Meta information extracted from the WSDL
     * - documentation: No card.
     * @return string 'None'
     */
    const VALUE_NONE = 'None';
    /**
     * Constant for value 'BlankCard'
     * Meta information extracted from the WSDL
     * - documentation: Blank card.
     * @return string 'BlankCard'
     */
    const VALUE_BLANK_CARD = 'BlankCard';
    /**
     * Constant for value 'CustomCard'
     * Meta information extracted from the WSDL
     * - documentation: Customized card.
     * @return string 'CustomCard'
     */
    const VALUE_CUSTOM_CARD = 'CustomCard';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_NONE
     * @uses self::VALUE_BLANK_CARD
     * @uses self::VALUE_CUSTOM_CARD
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NONE,
            self::VALUE_BLANK_CARD,
            self::VALUE_CUSTOM_CARD,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
