<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Cancel ServiceType
 * @subpackage Services
 */
class Cancel extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Cancel
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1105] - Enables the cancellation of a sales document, without having blocked it before.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Cancel $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CancelResponse|bool
     */
    public function Cancel(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Cancel $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->Cancel($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CancelResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
