<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Create ServiceType
 * @subpackage Services
 */
class Create extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Create
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Enables the creation of a sales document.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreateResponse|bool
     */
    public function Create(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->Create($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreateResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
